<?php

//Error_Reporting(0);

require('../../modules/yandex_easy_pay/functions.dat'); // функции
require('../../modules/yandex_easy_pay/y_key.dat'); // секретный ключ от Яндекс

$r = array(
	'notification_type' => $_POST['notification_type'], // p2p-incoming / card-incoming - с кошелька / с карты
	'operation_id'      => $_POST['operation_id'],      // Идентификатор операции в истории счета получателя.
	'amount'            => $_POST['amount'],            // Сумма, которая зачислена на счет получателя.
	'withdraw_amount'   => $_POST['withdraw_amount'],   // Сумма, которая списана со счета отправителя.
	'currency'          => $_POST['currency'],          // Код валюты — всегда 643 (рубль РФ согласно ISO 4217).
	'datetime'          => $_POST['datetime'],          // Дата и время совершения перевода.
	'sender'            => $_POST['sender'],            // Для переводов из кошелька — номер счета отправителя. Для переводов с произвольной карты — параметр содержит пустую строку.
	'codepro'           => $_POST['codepro'],           // Для переводов из кошелька — перевод защищен кодом протекции. Для переводов с произвольной карты — всегда false.
	'sha1_hash'         => $_POST['sha1_hash']          // SHA-1 hash параметров уведомления.
);
$y_data = $_POST['label']; // получаем данные из поля label - (номер заказа, товар/услуга/id, цена, e-mail администратора в настройках движка)


// лог
if ($on_off_y_log == 'checked')
{
$r['label'] = $y_data;
$log = "\n\n\n";
foreach ($r as $key => $value) 
 {
   $log.= $key.' => '.htmlspecialchars($value)."\n";
 }
$file = '../../modules/yandex_easy_pay/log.dat';
if (filesize($file)  >  50000) { file_put_contents($file, $log); } else { file_put_contents($file, $log, FILE_APPEND); }
}


// проверка хеш
if (sha1($r['notification_type'].'&'.
         $r['operation_id'].'&'.
         $r['amount'].'&'.
         $r['currency'].'&'.
         $r['datetime'].'&'.
         $r['sender'].'&'.
         $r['codepro'].'&'.
         $y_key.'&'.
         $y_data) != $r['sha1_hash']) 
 { 
   if ($on_off_y_log == 'checked') { file_put_contents('../../modules/yandex_easy_pay/log.dat', 'Верификация не пройдена. SHA1_HASH не совпадает'."\n", FILE_APPEND); }
   exit('Верификация не пройдена. SHA1_HASH не совпадает.'); // останавливаем скрипт   
 }
 

$y_data = htmlspecialchars($y_data); // фильтруем
$y_data = explode('|', $y_data); // преобразуем в массив по разделителю
$y_order = $y_data[0]; // номер заказа
$y_sum = $y_data[1]; // цена 
$y_mail = $y_data[2]; // e-mail администратора в настройках движка
//$y_name = $y_data[3]; // товар/услуга/id; не используется, т.к. в поле label 65 символов (текст может быть обрезан)


// проверка файла с заказом 
IF (!file_exists('../../modules/yandex_easy_pay/orders/'.$y_order.'.dat'))
 { 
   if ($on_off_y_log == 'checked') { file_put_contents('../../modules/yandex_easy_pay/log.dat', 'Не найден файл с заказом. Возможно, перевод не через форму сайта.'."\n", FILE_APPEND); }
   exit('Не найден файл с заказом. Возможно, перевод не через форму сайта.'); // останавливаем скрипт
 }
ELSE // если файл с заказом существует 
 { 
   // для вывода способа оплаты в админке
   if ($r['sender'] == '') { $sender = ' c банковской карты'; } else { $sender = ' из кошелька: '.htmlspecialchars($r['sender']).''; }
   
   $r['withdraw_amount'] = floatval($r['withdraw_amount']); // фильтруем
   $y_sum = floatval($y_sum); // фильтруем
   
   // проверка что бы cумма, которая списана со счета отправителя не была меньше запрашиваемой и платеж не был защищен кодом протекции
   if ($r['withdraw_amount'] < $y_sum && $r['codepro'] == false) 
    {
      file_put_contents('../../modules/yandex_easy_pay/orders/'.$y_order.'.dat', '<p style="color:red; font-size:10pt; text-decoration:underline;">&uarr; Сумма списанная со сч. отправителя: '.$r['withdraw_amount'].' руб, должна быть: '.$y_sum.' руб. Заказ оплачен '.$sender.', id в истории: '.intval($r['operation_id']).', дата совершения перевода: '.htmlspecialchars($r['datetime']).' &uarr;</p>', FILE_APPEND);
    } 
   // иначе, запись об оплате заказа в админку, отправка уведомления на e-mail + еще что-нибудь...
   else
    {
	  $r['datetime'] = htmlspecialchars($r['datetime']); // фильтруем
	  file_put_contents('../../modules/yandex_easy_pay/orders/'.$y_order.'.dat', '<p style="color:green; font-size:10pt; text-decoration:underline;">&uarr; Сумма списанная со сч. отправителя: '.$r['withdraw_amount'].' руб. Заказ оплачен '.$sender.', id в истории: '.intval($r['operation_id']).', дата совершения перевода: '.$r['datetime'].' &uarr;</p>', FILE_APPEND);
	  
	  // отправка на e-mail
	  if($y_mail != '') 
	   {
		$y_site = $_SERVER['SERVER_NAME']; // сайт
		$txt = "\n\n\n";
		$txt.= 'Заказ с сайта '.$y_site.' №: '.$y_order.' оплачен.';
		//$txt.= '---' . "\n";
		//$txt.= 'Товар/услуга/id: ' . $y_name . "\n"; // не используется, т.к. в поле label 65 символов (текст может быть обрезан)
		$txt.= '---' . "\n";
		$txt.= 'Цена: ' . $y_sum . "\n";
		$txt.= '---' . "\n";
		$txt.= 'Дата оплаты: ' . $r['datetime']  . "\n";	  
	  
		y_addmail($y_mail, "Сообщение об оплате заказа с сайта $y_site", $txt);
	   }
	  
	  // ...здесь может быть дополнительный код
	}
	
 }


?>